/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lesson4;

import java.util.Objects;

/**
 *
 * @author student
 */
public class Student implements Comparable {

    private String name;
    private int age;
    private final char gender;

    public Student(String name, int age, char gender) {
        this.name = name;
        this.age = age;
        this.gender = gender;
    }

    @Override
    public String toString() {
        switch (this.gender) {
            case 'm':
                return name + " " + age + " (male)";
            case 'f':
                return name + " " + age + " (female)";
            default:
                assert false : "Gender prolem"; 
        }//switch
        return "";
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    @Override
    public int compareTo(Object t) {
        //compare the name of this object to the name of t (casted to a Student) compare the age as well
        return this.getName().compareTo(((Student) t).getName());
    }

    @Override
    public int hashCode() {
        int hash = 3;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Student other = (Student) obj;
        if (!Objects.equals(this.name, other.name)) {
            return false;
        }
        if (this.age != other.age) {
            return false;
        }
        if (this.gender != other.gender) {
            return false;
        }
        return true;
    }

    

}//Student class
